﻿@page "/customer"

<h3>Manage Customer</h3>

<p>
    <a href="/customer/create" class="btn btn-primary">
        Create new customer
    </a>
</p>

<table class="table table-striped">
    <thead>
        <tr>
            <th>ID</th>
            <th>Name</th>
            <th>Email</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in CustomerList)
        {
            <tr>
                <td>@item.ID</td>
                <td>@item.Name</td>
                <td>@item.Email</td>
                <td>
                    <a href="@GetCustomerEditLink(item.ID)" class="btn btn-warning btn-sm">Edit</a>
                </td>
            </tr>
        }
    </tbody>
</table>

@code {
    [Inject] public IDbContextFactory<ShopDbContext> DbFactory { set; get; }

    public List<CustomerListItem> CustomerList { set; get; } = new List<CustomerListItem>();

    public string GetCustomerEditLink(Guid id)
    {
        return "/customer/edit/" + id;
    }

    protected override async Task OnInitializedAsync()
    {
        using var db = DbFactory.CreateDbContext();

        CustomerList = await db.Customers
            .AsNoTracking()
            .Select(Q => new CustomerListItem
            {
                ID = Q.CustomerID,
                Name = Q.Name,
                Email = Q.Email
            }).ToListAsync();
    }

    public class CustomerListItem
    {
        public Guid ID { set; get; }

        public string Name { set; get; }

        public string Email { set; get; }
    }
}
